/***************************************************************************
 *   Copyright (C) 2005-2006 by Steffen Wendzel                            *
 *   cdp {at} doomed-reality {dot} org                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "fupids2.h"

Directory::Directory()
{
	dirfp=NULL;
	dp=NULL;
	bzero(username, 512+1);
	bzero(cmdname, 8192+1);
}

// 
// returns -1 if the whole directory is done. in the other case
// the expected values will be set.
// 

bool Directory::next_element()
{
	if(dirfp==NULL)
		dirfp=opendir(INCOMING_DIR);
		
	if(dirfp) {
		if((dp=readdir(dirfp))!=NULL) {
			while(dp!=NULL && (strcmp(dp->d_name, ".")==0 || strcmp(dp->d_name, "..")==0
				|| dp->d_name[strlen(dp->d_name)-1]=='%' /* race cond. killer */)) {
#ifdef DEBUG
				printf("didn't open file %s\n", dp->d_name);
#endif
				dp=readdir(dirfp);
			}
			if(dp==NULL) { /* all is parsed */
				closedir(dirfp);
				dirfp=NULL;
				return false;
			}
			
			/* got an entry */
			return true;
		} else {
			closedir(dirfp);
			dirfp=NULL;
			return false;
		}
	} else {
		syslog(SYSL_ERR, "cannot access " INCOMING_DIR);
		sleep(50); // + 10 = one minute
	}
	return true;
}

