/***************************************************************************
 *   Copyright (C) 2005-2006 by Steffen Wendzel                            *
 *   cdp {at} doomed-reality {dot} org                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "fupids2.h"

int atk_roomchg,
    atk_seatchg,
    atk_etagechg,
    atk_buildingchg,
    atk_tools,
    atk_time,
    atk_date;

Log::Log()
{
	if(!(fp=fopen(LOGFILE, "a+"))) {
		syslog(SYSL_ERR, "unable to open " LOGFILE " in append-mode (a+).");
		exit(1);
	}
	
	atk_roomchg=atk_seatchg=atk_etagechg=atk_buildingchg=atk_tools=atk_time=atk_date=0;
}

Log::~Log()
{
	fclose(fp);
}

void Log::writeline(char *username, float atklvl)
{
	char *timestr;
	char atklvlstr[20]={'\0'};
	const time_t x=time(NULL);
	unsigned int i=0;
	
	if(!fp) {
		syslog(SYSL_ERR, "internal error. 0xa01. please report that.\n");
		exit(1);
	}
	/* timestamp */
	timestr=ctime(&x);
	timestr[strlen(timestr)-1]='!';
	if(fwrite(timestr, strlen(timestr), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	/* username */
	if(fwrite(username, strlen(username), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	/* attacker level */
	snprintf(atklvlstr, 19, "!%1.0f!", atklvl);
	if(fwrite(atklvlstr, strlen(atklvlstr), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	bzero(atklvlstr, 20);
	if(atk_roomchg)
		atklvlstr[i++]='R';
	else if(atk_seatchg)
		atklvlstr[i++]='S';
	else if(atk_etagechg || atk_buildingchg)
		atklvlstr[i++]='B';
	else if(atk_tools)
		atklvlstr[i++]='P';
	else if(atk_time)
		atklvlstr[i++]='T';
	else if(atk_date)
		atklvlstr[i++]='D';
	else
		atklvlstr[i++]='?';
	
	atklvlstr[i]='\n';
	if(fwrite(atklvlstr, strlen(atklvlstr), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
   // cleanup the flags
   atk_roomchg=atk_seatchg=atk_etagechg=atk_buildingchg=atk_tools=atk_time=atk_date=0;
   
	fflush(fp);
}

void Log::writeline(char *username, char *progname, char flag)
{
	char *timestr;
	char atklvlstr[30]={'\0'};
	const time_t x=time(NULL);
	
	if(!fp) {
		syslog(SYSL_ERR, "internal error. 0xa01. please report that.\n");
		exit(1);
	}
	/* timestamp */
	timestr=ctime(&x);
	timestr[strlen(timestr)-1]='!';
	if(fwrite(timestr, strlen(timestr), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	/* username */
	if(fwrite(username, strlen(username), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	/* attacker level */
	if(flag=='K')
		atklvlstr[0]='';
	else
		atklvlstr[0]='$';
	if(fwrite(atklvlstr, 1, 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	if(fwrite(progname, strlen(progname), 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	atklvlstr[0]='\n';
	if(fwrite(atklvlstr, 1, 1, fp)!=1) {
		syslog(SYSL_ERR, "unable to write log entry to " LOGFILE);
		return;
	}
	
	fflush(fp);
}

